#include <bits/stdc++.h>

using namespace std;

int main()
{
    vector<tuple<int, int>> tacke;
    int x, y, n;
    scanf("%d", &n);
    scanf("%d%d", &x, &y);
    tacke.push_back(make_tuple(x, y));
    int maxx = x, maxy = y;
    int minx = x, miny = y;

    for(int i = 1; i < n; i++)
    {
        scanf("%d%d", &x, &y);
        tacke.push_back(make_tuple(x, y));
        if(x > maxx)
            maxx = x;
        if(y > maxy)
            maxy = y;
        if(x < minx)
            minx = x;
        if(y < miny)
            miny = y;
    }

    printf("0");
    int p, maxp, tempx, tempy;
    int br = 0;
    for(int i = 1; i < n; i++)
    {
        maxp = 0;
        for(int x = minx; x <= maxx; x++)
        {
            for(int y = miny; x <= maxy; y++)
            {
                p = 0;
                for(int j = 0; j < n; j++)
                {
                    for(int k = 0; k < n; k++)
                    {
                        tempx = get<0>(tacke[j]);
                        tempy = get<1>(tacke[k]);
                        if(tempx == x && tempy == y)
                        {
                            br++;
                            break;
                        }
                    }
                    if(br)
                    {
                        break;
                    }
                }
                if(br)
                {
                    for(int j = 0; j < n; j++)
                    {
                        for(int k = 0; k < n; k++)
                        {
                            tempx = get<0>(tacke[j]);
                            tempy = get<1>(tacke[k]);
                            p += abs(tempx - x) * abs(tempy - y);
                        }
                    }
                }
                if(p > maxp)
                {
                    maxp = p;
                }
            }
        }
        maxp %= 1000000007;
        printf("\n%d", maxp);
    }
    return 0;
}